var wp_panda_mailer_emailAuthTimer = null;
jQuery(function($){
	//bind keypress to clear error state from captcha input
        $('#wp_panda_mailer_verification-code').keydown(function() {
		$("#wp_panda_mailer_captcha-pass").addClass("wp_panda_mailer_hide");   
                $("#wp_panda_mailer_captcha-fail").addClass("wp_panda_mailer_hide");
        });

        //bind keypress to clear error state from user message
        $('#wp_panda_mailer_user-message').keydown(function() {
                $("#wp_panda_mailer_message-pass").addClass("wp_panda_mailer_hide");
                $("#wp_panda_mailer_message-fail").addClass("wp_panda_mailer_hide");
        });

	//bind to recipient list for validation
        $("#wp_panda_mailer_recipient-list").change(function(){
                $("#wp_panda_mailer_recipient-pass").addClass("wp_panda_mailer_hide");
                $("#wp_panda_mailer_recipient-fail").addClass("wp_panda_mailer_hide");
                
                if($('#wp_panda_mailer_recipient-list').val() > -1){
                        $("#wp_panda_mailer_recipient-pass").removeClass("wp_panda_mailer_hide");
                }else{
                        $("#wp_panda_mailer_recipient-pass").addClass("wp_panda_mailer_hide");   
                        $("#wp_panda_mailer_recipient-fail").removeClass("wp_panda_mailer_hide");
                }
        });

	//bind to subject list for validation
	$("#wp_panda_mailer_subject-list").change(function(){
                $("#wp_panda_mailer_subject-pass").addClass("wp_panda_mailer_hide");
                $("#wp_panda_mailer_subject-fail").addClass("wp_panda_mailer_hide");

		if($('#wp_panda_mailer_subject-list').val() > -1){
			$("#wp_panda_mailer_subject-pass").removeClass("wp_panda_mailer_hide");
		}else{
			$("#wp_panda_mailer_subject-pass").addClass("wp_panda_mailer_hide");
			$("#wp_panda_mailer_subject-fail").removeClass("wp_panda_mailer_hide");
		}
	});

	//bind keypress for real time email auth
	$('#wp_panda_mailer_user-email-input').keydown(function() {
		clearTimeout(wp_panda_mailer_emailAuthTimer); 
		wp_panda_mailer_emailAuthTimer = setTimeout(wp_panda_mailer_authEmail, 500);
	});

	//verify valid email address
	function wp_panda_mailer_authEmail() {
	  if (!($('#wp_panda_mailer_user-email-input').prop('value').indexOf("@") > 0 && $('#wp_panda_mailer_user-email-input').prop('value').indexOf(".") > 0 && $('#wp_panda_mailer_user-email-input').prop('value').indexOf(".")+2 < $('#wp_panda_mailer_user-email-input').prop('value').length)){
		$("#wp_panda_mailer_email-pass").addClass("wp_panda_mailer_hide");
		$("#wp_panda_mailer_email-fail").removeClass("wp_panda_mailer_hide");
	  }else{
		$("#wp_panda_mailer_email-pass").removeClass("wp_panda_mailer_hide");
		$("#wp_panda_mailer_email-fail").addClass("wp_panda_mailer_hide");
	  }
	}


	//Add in watermarks for various fields.
	$("#wp_panda_mailer_user-email-input").Watermark(" your-email@somedomain.com ");
	$("#wp_panda_mailer_verification-code").Watermark(" enter code "); 
	$("#wp_panda_mailer_user-message").Watermark(" enter a message here");
});


//The following functions will check for blank fields in the form.
function wp_panda_mailer_trimAll(sString)
{
  while (sString && sString.substring(0,1) == " ")
  {
    sString = sString.substring(1, sString.length);
  }
  while (sString && sString.substring(sString.length-1, sString.length) == " ")
  {
    sString = sString.substring(0,sString.length-1);
  }     
  return sString;
}

function wp_panda_mailer_checkform (form)
{

  var formReturn = true;

  // ** FROM **
  tmpCompare=wp_panda_mailer_trimAll(form.from.value);
  if (tmpCompare == "" || tmpCompare == "your-email@somedomain.com") {
    jQuery(function($){    
	    $("#wp_panda_mailer_email-pass").addClass("wp_panda_mailer_hide");
	    $("#wp_panda_mailer_email-fail").removeClass("wp_panda_mailer_hide");
    });
    //form.from.focus();
    formReturn = false;
  }else{
    //check if email looks like an email address
    if (!(form.from.value.indexOf("@") > 0 && form.from.value.indexOf(".") > 0 && form.from.value.indexOf(".")+2 < form.from.value.length) && wp_panda_mailer_trimAll(form.from.value.text) != "your-email@somedomain.com"){
      jQuery(function($){
            $("#wp_panda_mailer_email-pass").addClass("wp_panda_mailer_hide");
            $("#wp_panda_mailer_email-fail").removeClass("wp_panda_mailer_hide");
      });
      form.from.focus();
      formReturn = false; 
    }else{
        jQuery(function($){
            $("#wp_panda_mailer_email-pass").removeClass("wp_panda_mailer_hide");
            $("#wp_panda_mailer_email-fail").addClass("wp_panda_mailer_hide");   
        });
    }
  }
  // ** RECIPIENT **
    tmpCompare=wp_panda_mailer_trimAll(form.recipient.value);
    if (tmpCompare < 0) {
	jQuery(function($){
            $("#wp_panda_mailer_recipient-pass").addClass("wp_panda_mailer_hide");
            $("#wp_panda_mailer_recipient-fail").removeClass("wp_panda_mailer_hide");
	});
        formReturn = false;
    }else{
	jQuery(function($){
            $("#wp_panda_mailer_recipient-pass").removeClass("wp_panda_mailer_hide");
            $("#wp_panda_mailer_recipient-fail").addClass("wp_panda_mailer_hide");
    	});
    }

  // ** SUBJECT **
    tmpCompare=wp_panda_mailer_trimAll(form.subject.value);
    if (tmpCompare < 0) {
	jQuery(function($){
            $("#wp_panda_mailer_subject-pass").addClass("wp_panda_mailer_hide");
            $("#wp_panda_mailer_subject-fail").removeClass("wp_panda_mailer_hide");
	});
      formReturn = false;
    }else{
        jQuery(function($){
            $("#wp_panda_mailer_subject-pass").removeClass("wp_panda_mailer_hide");
            $("#wp_panda_mailer_subject-fail").addClass("wp_panda_mailer_hide");
        });
    }  

  // ** MESSAGE **
    tmpCompare=wp_panda_mailer_trimAll(form.message.value);
    if (tmpCompare == "" || tmpCompare == "enter a message here") {
        jQuery(function($){
            $("#wp_panda_mailer_message-pass").addClass("wp_panda_mailer_hide");
            $("#wp_panda_mailer_message-fail").removeClass("wp_panda_mailer_hide");
        });
      form.message.focus();
      formReturn = false;
    }else{
        jQuery(function($){
            $("#wp_panda_mailer_message-pass").removeClass("wp_panda_mailer_hide"); 
            $("#wp_panda_mailer_message-fail").addClass("wp_panda_mailer_hide");
        });
    }

  // ** VERIFICATION CODE **
    tmpCompare=wp_panda_mailer_trimAll(form.response.value);
    if (tmpCompare == "" || tmpCompare == "enter code") {
        jQuery(function($){
            $("#wp_panda_mailer_captcha-fail").removeClass("wp_panda_mailer_hide");
        });
      form.response.focus();
      formReturn = false;
    }else{
        jQuery(function($){
            $("#wp_panda_mailer_captcha-fail").addClass("wp_panda_mailer_hide");
            $("#wp_panda_mailer_captcha-pass").removeClass("wp_panda_mailer_hide");
        });
    }

    if(formReturn == true){
	return true;
    }else{
	return false;
    }
}