<?php
//#############################################################################\\
//# PANDA Mailer                                                              #\\
//# Author: Christopher Schiffner - chris@schiffner.com                       #\\
//# Copyright: Christopher Schiffner - 2015                                   #\\
//#                                                                           #\\  
//#############################################################################\\
// We'll be outputting CSS
header('Content-type: text/css');
?>

form#wp_panda_mailer{
	clear: both;
	width: 100%;
	max-width:  550px;
}

form#wp_panda_mailer .wp_panda_mailer_error{
	clear: both;
	display: block;
	width: 80%;
	max-width: 430px;
	margin-top: 8px !important;
	margin-bottom: 15px !important;
	margin: 0 auto;
	padding: 10px;
	background: #f7f7f7;
	border-left: 7px solid #ea3737;
	border-top: 1px solid #ccd0d4;
	border-bottom: 1px solid #ccd0d4;
	border-right: 1px solid #ccd0d4;
	border-top-right-radius: 3px;
	border-bottom-right-radius: 3px;
	text-align: center;
	color: #444;
}

	form#wp_panda_mailer .wp_panda_mailer_sent{
	clear: both;
	display: block;
	width: 80%;
	max-width: 430px;
	margin-top: 8px !important;
	margin-bottom: 15px !important;
	margin: 0 auto;
	padding: 10px;
	background: #f7f7f7;
	border-left: 7px solid #46b451;
	border-top: 1px solid #ccd0d4;
	border-bottom: 1px solid #ccd0d4;
	border-right: 1px solid #ccd0d4;
	border-top-right-radius: 3px;
	border-bottom-right-radius: 3px;
	text-align: center;
	color: #444;
}

form#wp_panda_mailer input, form#wp_panda_mailer textarea, form#wp_panda_mailer select{
	color: #484743;
	border: 1px solid #aaa;
	background: #fff;
	-moz-border-radius: 4px;
	-webkit-border-radius: 4px;
	border-radius: 4px;
}

form#wp_panda_mailer input:focus, form#wp_panda_mailer textarea:focus{
	-webkit-box-shadow: 0 0 8px rgba(51, 204, 255, 0.5);
	-moz-box-shadow: 0 0 8px rgba(51, 204, 255, 0.5);
	box-shadow: 0 0 8px rgba(51, 204, 255, 0.5);
}

form#wp_panda_mailer .wp_panda_mailer_user-email-label{
	margin: 10px 0 0 0;
}

form#wp_panda_mailer #wp_panda_mailer_user-email-input{
	width: 245px;
	height: 30px;
	margin-bottom: 10px;
	margin-right: 5px;
	font-size: 15px;
}

form#wp_panda_mailer #wp_panda_mailer_recipient-list{
	width: 250px;
	margin-bottom: 10px;
	margin-right: 5px;
}

form#wp_panda_mailer #wp_panda_mailer_subject-list{
	width: 250px;
	margin-bottom: 10px;
	margin-right: 5px;
}

form#wp_panda_mailer #wp_panda_mailer_user-message{
	width: 100%;
	max-width: 550px;
	min-width: 240px;
	height: 175px;
	margin: 2px 0 15px 0;
	font-size: 15px;
}

form#wp_panda_mailer #wp_panda_mailer_verification{
	position: relative;
}

form#wp_panda_mailer #wp_panda_mailer_verification-image{
	display: inline;
	vertical-align: top;
    -moz-border-radius: 4px;   
    -webkit-border-radius: 4px;
    margin-right: 15px;
    margin-bottom: 8px;
    border-radius: 4px;
}
form#wp_panda_mailer #wp_panda_mailer_verification-code{
	display: inline;
	vertical-align: top;
	width: 145px;
	height: 40px;
	margin-right: 5px;
	text-align: center;
	font-size: 15px;
}

form#wp_panda_mailer #wp_panda_mailer_captcha-pass, form#wp_panda_mailer #wp_panda_mailer_captcha-fail{
	top: 1px;
}

form#wp_panda_mailer .wp_panda_mailer_auth-images{
	position: relative;
	top: -1px;
	width: 16px;
	height: 16px;
}
form#wp_panda_mailer #wp_panda_mailer_verification .wp_panda_mailer_auth-images{
	vertical-align: middle;
}

form#wp_panda_mailer .wp_panda_mailer_hide{
	display: none;
}

form#wp_panda_mailer .wp_panda_mailer_send-clear{
	clear: both;
}

form#wp_panda_mailer input#wp_panda_mailer_send-message{
	clear: both;
	padding: 5px;
	float: right;
	color: #44413e;
	background: #ccc;
	font-weight: normal; 
	letter-spacing: .1em;
	text-transform: uppercase;
	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.85);
	border: 1px solid #aaa; 
	-moz-border-radius: 6px;   
	-webkit-border-radius: 6px;
	border-radius: 12px;
	cursor: pointer;
	margin: 8px 0 10px 0;
	font-size: 16px;
}

